
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"
#include <unistd.h>


#include "main.h"


Uint32 TimeLeft(void)
{
    static Uint32 next_time = 0;
    Uint32 now;

    now = SDL_GetTicks();
    if ( next_time <= now ) {
        next_time = now+TICK_INTERVAL;
        return(0);
    }
    return(next_time-now);
}


int load_files()
{
    background = load_image( "modelo2.jpg" );
    if( background == NULL )  return 0;
    
    background2 = load_image( "modelo3.jpg" );
    if( background2 == NULL )  return 0;
    
	dots = load_image( "modelo1.png" );
    if( dots == NULL )  return 0;

    font = TTF_OpenFont( "seta.ttf", 20 );
	if( font == NULL )
    {
		printf("Error cargando Font\n");
        return 0;
    }
	// Cargamos sonido
	if(SONIDO)sonido = Mix_LoadWAV("modelo.wav");
 	if(SONIDO)if ( sonido == NULL )
		{
		 printf("No pude cargar sonido: %s\n", Mix_GetError());
//     	 return 0;
 		}
  return 1;
}

void RepintarPantalla()
{
    SDL_WM_SetCaption( "Control Arduino con Raspberry PI", NULL );
	apply_surface( 0, 0, background, screen );
    message = TTF_RenderText_Solid( font, "SDL_Control", textColor );
	apply_surface( 270, 1, message, screen );
	
	PaintBotones();	
	PaintLuces();
	PaintEntradas ();
	PaintTextos();
	SDL_Flip( screen );
}



void PaintZona1(int z)
{
  SDL_Rect clip;
		clip.x = nzona[z].x;
	    clip.y = nzona[z].y;
    	clip.w = nzona[z].w;
    	clip.h = nzona[z].h;
    	apply_surfaceB( nzona[z].x, nzona[z].y, background2, screen, &clip );
}

void PaintZona(int z)
{
  SDL_Rect clip;
		clip.x = nzona[z].x;
	    clip.y = nzona[z].y;
    	clip.w = nzona[z].w;
    	clip.h = nzona[z].h;
    	apply_surfaceB( nzona[z].x, nzona[z].y, background, screen, &clip );
}



void RSwrite(char *cade)
{	
 int z;
	z=strlen(cade);
	if(DEBUG)printf("--cade->%s tamano_%d\n",cade,z);
	write(fdrs232,cade,z);
}



void fClearA()
{
 int z;
	RSwrite("0An0\n");
	RSwrite("0An1\n");
	RSwrite("0An2\n");
	RSwrite("0An3\n");
	RSwrite("0An4\n");
	RSwrite("0An5\n");

    for(z=0;z<6;z++)
		{
		nzona[z].estado=0;
		PaintZona(z);
		}

	if(DEBUG)printf("Borrar Analogicos\n");
}

void fClearD()
{
 int z;
 
	RSwrite("0Dig2\n");
	RSwrite("0Dig3\n");
	RSwrite("0Dig4\n");
	RSwrite("0Dig5\n");
	RSwrite("0Dig6\n");
	RSwrite("0Dig7\n");
	RSwrite("0Dig8\n");
	RSwrite("0Dig9\n");
	RSwrite("0Dig10\n");
	RSwrite("0Dig11\n");
	RSwrite("0Dig12\n");
	RSwrite("0Dig13\n");

	for(z=6;z<18;z++)
		{
		nzona[z].estado=0;
		PaintZona(z);
		}	
	if(DEBUG)printf("Borrar Digitales\n");		
}	



int main (int argc, char *argv[])
{
 int quit = 0;
 int mouse_x,mouse_y;
 Uint8 *teclas; 
 int zboton=0;
 int canal;
 int zzona;


//_________________

#if YesWindows 
	freopen("CON", "w", stdout); // redirects stdout
	freopen("CON", "w", stderr); // redirects stderr
#endif

    printf("%s\n",argv[0]);
	if(argc==2)
		{
		 printf("%s\n",argv[1]);
 	 	 MODEMDEVICE=argv[1];
		}
	 else
		{
		 MODEMDEVICE=MODEMDEVICEdefault;
		}
	printf("Control salida Arduino ");

	printf(MODEMDEVICE);
	printf("\n");
	IniRs232();

//______________________
	


	
	Initextos();
	Inibotones();	
	IniLuces ();	
	Inientradas();
	Inizonas();

	
    if( init() == 0 ) return 1;	
    if( load_files() == 0 ) return 2;	
	
	RepintarPantalla();			
	if( SDL_Flip( screen ) == -1 ) return 3;
	if(SONIDO)canal = Mix_PlayChannel(-1, sonido, 0);
	fClearA();
	fClearD();
    
	 while( quit == 0 )
    {	
	  SDL_Delay(100);
	  if(!TimeLeft())
 	                {
	                if(DEBUG)printf("time\n");				
                    }

	  while( SDL_PollEvent( &event ) )
        {
			teclas = SDL_GetKeyState(NULL);
			if(teclas[SDLK_ESCAPE] ) quit = 1;
            if( event.type == SDL_QUIT )   quit = 1;
            if( event.type == SDL_KEYDOWN ) 
			{
				if(DEBUG)printf("Evento Tecla\n");
				if(event.key.keysym.sym == SDLK_f)
                    {  
          #if YesWindows
                     screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
          #else
                     SDL_WM_ToggleFullScreen(screen);
          #endif  
                     RepintarPantalla();
                    }
				if(event.key.keysym.sym == SDLK_m)
				 {
					screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );
					RepintarPantalla();
				 }
			}
			if( event.type == SDL_MOUSEBUTTONDOWN ) {
				mouse_x=event.button.x;
				mouse_y=event.button.y;
				zboton=DetecBotones(mouse_x,mouse_y);
				
				if(zboton!=-1)
					{     
					 if(SONIDO)canal = Mix_PlayChannel(-1, sonido, 0);                         
                 	 switch (zboton)
                        {                         
                         case 0:
							goto salir;                        
                         break;    
						 case 1:
							fClearD();                      
                         break;  
                         case 2:
							fClearA();                      
                         break;
                        default:                         
                     	printf("%s\n",VARI);					
                        }                               
					 PaintBoton(zboton,1);
					}

					if(DEBUG)printf("Evento Raton X=%d Y=%d Boton=%d\n",mouse_x,mouse_y,zboton);					
					if( SDL_Flip( screen ) == -1 ) return 3;
			}
			if( event.type == SDL_MOUSEBUTTONUP ) {
				if(zboton!=-1)
				  {
					PaintBotones();
//					PaintLuces();
					if(DEBUG)printf("RepintarBoton %d\n",zboton);
					zboton=-1;					
				  }
										
				zzona=DetecZonas(mouse_x,mouse_y);	
				if(DEBUG)printf("ZonaUp = %d\n",zzona);	
				if(zzona!=-1)
					{
					 if(nzona[zzona].estado==0)
						{
						nzona[zzona].estado=1;						
						sprintf(VARI,"1%s",nzona[zzona].nombre);						
						PaintZona1(zzona);	
						}
					   else
						{
						nzona[zzona].estado=0;						
						sprintf(VARI,"0%s",nzona[zzona].nombre);						
						PaintZona(zzona);	
						}
					 printf("%s\n",VARI);
#if YesWindows                     
                     WriteSerie(hSerial,VARI,7);
                     WriteSerie(hSerial,"\n",1);
#else
                     write(fdrs232,VARI,7);
                     write(fdrs232,"\n",1);             							
#endif                     					 
					 if(DEBUG)printf("estado zona %d \n",nzona[zzona].estado);
					 if(SONIDO)canal = Mix_PlayChannel(-1, sonido, 0);
					 //SDL_Flip( screen );
					}	
								
				if( SDL_Flip( screen ) == -1 ) return 3;
			}	
        }		
	}
		
	goto salir;	
salir: 
     //Cerrar todo el SDL
    clean_up();
	CloseRs232();

    return 0;  
}

//____________________FIN____________








int CloseRs232()
{
#if YesWindows    
    CloseHandle(hSerial);
#else    
	close(fdrs232);
#endif
	return 0;
}

int IniRs232()
{
#if YesWindows  	
 //____________Programacion serie Windows__________________________
 
 
         hSerial = CreateFile(MODEMDEVICE,GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING,0, NULL);

         if(hSerial==INVALID_HANDLE_VALUE)
           {
             if(GetLastError()==ERROR_FILE_NOT_FOUND)
              {
               printf("PUERTO NO EXISTE !! \n"); 
               return 0;
              }
           }
           else
           {
//            dcbSerial.DCBlength=sizeof(dcbSerialParams);
            if (!GetCommState(hSerial, &dcbSerialParams))
               {
                printf("Error get Status!!\n");
                return 0;
               }                           
            dcbSerialParams.BaudRate=BAURATEW;
            dcbSerialParams.ByteSize=8;
            dcbSerialParams.StopBits=ONESTOPBIT;
            dcbSerialParams.Parity=NOPARITY;
            if (!SetCommState (hSerial, &dcbSerialParams))
              {
               CloseHandle(hSerial);
               printf("Error get Status2!!\n");
               return 0;
              }           
            time_out.ReadIntervalTimeout = 20; 
            time_out.ReadTotalTimeoutMultiplier = 2; 
            time_out.ReadTotalTimeoutConstant = 50; 
            time_out.WriteTotalTimeoutMultiplier = 2; 
            time_out.WriteTotalTimeoutConstant = 50;  
            if (SetCommTimeouts(hSerial, &time_out)==0)
               printf("Error SetCommTimeouts \n"); 
           }
#else
//_________Programacion Linux________________________

	
	fdrs232 = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NDELAY );
   	if (fdrs232 <0) 
		{
		 printf("Error puerto de comunicaciones\n");
		 exit(-1);  
		}	
  newtermios.c_cflag= BAUDRATE | CS8 | CLOCAL | CREAD;
  newtermios.c_iflag=IGNPAR;
  newtermios.c_oflag=0;
  newtermios.c_lflag=0;
  newtermios.c_cc[VMIN]=1;
  newtermios.c_cc[VTIME]=0;

  cfsetospeed(&newtermios,BAUDRATE);
  cfsetispeed(&newtermios,BAUDRATE);
 
  if (tcflush(fdrs232,TCIFLUSH)==-1) return -1;
  if (tcflush(fdrs232,TCOFLUSH)==-1) return -1;
  if (tcsetattr(fdrs232,TCSANOW,&newtermios)==-1) return -1;  

  //Hace que el puerto serie no espere	
  fcntl(fdrs232, F_SETFL, O_NDELAY );	
#endif

	return 0;
}

